Bug 203795

Summary: [JSC] Use LinkTimeConstants and make some properties lazy
Product: WebKit Reporter: Yusuke Suzuki <ysuzuki>
Component: JavaScriptCoreAssignee: Yusuke Suzuki <ysuzuki>
Status: RESOLVED FIXED    
Severity: Normal CC: ews-watchlist, keith_miller, mark.lam, msaboff, sbarati, tzagallo, webkit-bug-importer
Priority: P2 Keywords: InRadar
Version: WebKit Nightly Build   
Hardware: Unspecified   
OS: Unspecified   
Bug Depends on: 153792    
Bug Blocks:    
Attachments:
Description Flags
Patch
none
Patch
none
Patch keith_miller: review+

Description Yusuke Suzuki 2019-11-02 21:37:50 PDT
...
Comment 1 Yusuke Suzuki 2019-11-06 19:18:14 PST
Created attachment 383009 [details]
Patch
Comment 2 Yusuke Suzuki 2019-11-07 17:53:06 PST
Created attachment 383098 [details]
Patch
Comment 3 Yusuke Suzuki 2019-11-07 17:56:11 PST
Created attachment 383099 [details]
Patch
Comment 4 Keith Miller 2019-11-07 18:20:02 PST
Comment on attachment 383099 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=383099&action=review

r=me with comments.

> Source/JavaScriptCore/runtime/JSGlobalObject.cpp:2015
> +    if (m_mapIteratorProtocolWatchpointSet.isStillValid()) {

Can't this be an ASSERT? How can this not be valid if you haven't initialized Map.prototype? I don't think it's possible to access the Map iterator prototype object without first creating a Map.

> Source/JavaScriptCore/runtime/JSGlobalObject.cpp:2030
> +    if (m_setIteratorProtocolWatchpointSet.isStillValid()) {

ditto.
Comment 5 Yusuke Suzuki 2019-11-07 18:47:10 PST
Comment on attachment 383099 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=383099&action=review

Thanks!

>> Source/JavaScriptCore/runtime/JSGlobalObject.cpp:2015
>> +    if (m_mapIteratorProtocolWatchpointSet.isStillValid()) {
> 
> Can't this be an ASSERT? How can this not be valid if you haven't initialized Map.prototype? I don't think it's possible to access the Map iterator prototype object without first creating a Map.

This can be invalid because m_mapIteratorProtocolWatchpointSet is also checked by mapIteratorPrototype's change.

> Source/JavaScriptCore/runtime/JSGlobalObject.cpp:2020
> +    if (m_mapSetWatchpointSet.isStillValid()) {

On the other hand, this is only used here. So we can convert it to ASSERT. Fixed.

>> Source/JavaScriptCore/runtime/JSGlobalObject.cpp:2030
>> +    if (m_setIteratorProtocolWatchpointSet.isStillValid()) {
> 
> ditto.

Ditto. This can be invalid if setIteratorPrototype is changed.

> Source/JavaScriptCore/runtime/JSGlobalObject.cpp:2035
> +    if (m_setAddWatchpointSet.isStillValid()) {

Ditto. Fixed.
Comment 6 Yusuke Suzuki 2019-11-08 13:11:37 PST
Committed r252256: <https://trac.webkit.org/changeset/252256>
Comment 7 Radar WebKit Bug Importer 2019-11-08 13:12:15 PST
<rdar://problem/57031944>